/********************************************************************-*-c-*-*\
*               *  Class examples for Advanced Porgramming                   *
*    #####      *  (!) Giovanni Squillero <giovanni.squillero@polito.it>     *
*   ######      *                                                            *
*   ###   \     *  Copying and distribution of this file, with or without    *
*    ##G  c\    *  modification, are permitted in any medium without royalty *
*    #     _\   *  provided this notice is preserved.                        *
*    |   _/     *  This file is offered as-is, without any warranty.         *
*    |  _/      *                                                            *
*               *  See: http://staff.polito.it/giovanni.squillero/dida.php   *
\****************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include "knight.h"
#include "utils.h"

static int recKnightTour(int step);

static int Board[BOARD_SIZE][BOARD_SIZE];
static int PosX, PosY;

int KnightTour(int x, int y)
{
	int ret;
	
	PosX = x;
	PosY = y;
	Board[PosX][PosY] = 1;
	ret=recKnightTour(1);
	
	if(ret) {
		printf("Whoa!\n");
		for(x=0; x<BOARD_SIZE; ++x) {
			for(y=0; y<BOARD_SIZE; ++y) {
				printf("  %02d", Board[x][y]);
			}
			printf("\n");
		}
	} else {
		printf("Yeuch...\n");
	}
	
	return ret;
}

static int recKnightTour(int step)
{
	/* RIC(n)
	 *
	 *    finito? -> fai qualcosa
	 *
	 *    for p { possibili passi }
	 *        FAI(p);    <-- aggiornare variabili globali
	 *        RIC(n+1);
	 *        DISFA(p);  <-- backtrack
	 */
	 
	static struct { int ox; int oy; } Move[8] = {
	 	{ -2, -1 },
	 	{ -2, +1 },
	 	{ +2, -1 },
	 	{ +2, +1 },
	 	{ -1, -2 },
	 	{ -1, +2 },
	 	{ +1, -2 },
	 	{ +1, +2 } 
	};
	int p;

	 
	if(step == BOARD_SIZE*BOARD_SIZE)
	 	return 1;
	 
	for(p=0; p<8; ++p) {
	 	if(PosX+Move[p].ox >= 0 && PosX+Move[p].ox < BOARD_SIZE 
		   && PosY+Move[p].oy >= 0 && PosY+Move[p].oy < BOARD_SIZE
		   && Board[PosX+Move[p].ox][PosY+Move[p].oy] == 0) {

			PosX += Move[p].ox;
			PosY += Move[p].oy;
			Board[PosX][PosY] = step+1;

			if(recKnightTour(step+1))
				return 1;

			Board[PosX][PosY] = 0;
			PosY -= Move[p].oy;
			PosX -= Move[p].ox;

	 	}
	}
	return 0;
}	 

